using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.IO;
using System.Text;
public partial class Controls_USPSTrackShipmentl : System.Web.UI.UserControl
{
	protected void btnTrack_Click(object sender, EventArgs e)
	{
		lblOrderSummary.Text = string.Empty;
		string _resultXml = "";
		USPS.USPSTrack _trackShipment = new USPS.USPSTrack();
		_trackShipment.trackingNumer = txtTrackingNumber.Text;
		_resultXml = _trackShipment.RequestUSPSTrackingInfo();

		if (_resultXml == "E")
		{
			lblOrderSummary.Text = "An error ocurred while connecting to USPS server. Please check your Internet connection and try again";
			lblOrderSummary.CssClass = "Error";
		}
		else
		{
			XmlDocument xmlDoc = new XmlDocument();
			XmlElement root;
			xmlDoc.LoadXml(_resultXml);
			root = xmlDoc.DocumentElement;
			string firstNodeName = root.FirstChild.Name.ToString();
			if (firstNodeName == "Number")
			{
				lblOrderSummary.CssClass = "Error";
				string errNumber = root.SelectSingleNode("//Number").InnerText;
				string errSource = root.SelectSingleNode("//Source").InnerText;
				string errDescription = root.SelectSingleNode("//Description").InnerText;
				lblOrderSummary.Text = "Order Status: " + errDescription;
				grdTrackDetails.Visible = false;
			}
			else
			{
				if (root.SelectSingleNode("//Error")!=null)
				{
					lblOrderSummary.Text = root.SelectSingleNode("//Description").InnerText;
				}
				else
				{
					lblOrderSummary.CssClass = "Normal";
					grdTrackDetails.Visible = true;
					lblOrderSummary.Text = "Order Status: " + root.SelectSingleNode("//TrackSummary").InnerText;
					XmlNodeList nodes = xmlDoc.SelectNodes("//TrackDetail");

					StringBuilder sb = new StringBuilder("<TrackDetail>");
					foreach (XmlNode n in nodes)
						sb.Append(n.OuterXml);
					sb.Append("</TrackDetail>");

					XmlNodeReader reader = null;
					//re-load the xml document without the error attribute 
					xmlDoc.LoadXml(sb.ToString());
					reader = new XmlNodeReader(xmlDoc);

					// Create a dataset to hold the result
					DataSet ds = new DataSet();
					ds.ReadXml(reader);

					// Show the result in a grid view
					grdTrackDetails.DataSource = ds;
					grdTrackDetails.DataBind();
				}
			}
		}
	}
}
